-- entity parts

empty_sprite =
{
  filename = "__core__/graphics/empty.png",
  priority = "extra-high",
  frame_count = 1,
  width = 1,
  height = 1
}

interface_led =
{
  filename = "__base__/graphics/entity/combinator/activity-leds/decider-combinator-LED-S.png",
  width = 12,
  height = 12,
  frame_count = 1,
  --shift = {-0.28125, -0.34375}
  shift = {-0.15, -0.29}
}

interface_connection =
{
  shadow =
  {
    red = {0.796875, 0.5},
    green = {0.203125, 0.5},
  },
  wire =
  {
    red = {0.296875, 0.0625},
    green = {-0.296875, 0.0625},
  }
}

-- default reactor (running reactor)
reactor_template =
{
    type = "reactor",
    name = "realistic-reactor",
	icon = "__RealisticReactors__/graphics/icons/nuclear-reactor.png",
    icon_size = 32,
	order = "f[nuclear-energy]-a[reactor]",
    flags = {"placeable-neutral", "player-creation", "placeable-off-grid", "not-on-map","not-deconstructable","not-blueprintable"},
	--placeable_by = { item="iron-plate", count = 1},
    --minable = {mining_time = 1.5, result = "realistic-reactor"},
    max_health = 500,
    corpse = "big-remnants",
    consumption = "40MW",
    neighbour_bonus = 1,
	selectable_in_game = false,
    burner =
    {
      fuel_category = "nuclear",
      effectivity = 1,
      fuel_inventory_size = 1,
      burnt_inventory_size = 1
    },
    --collision_box = {{-2.2, -2.2}, {2.2, 2.2}},
    --selection_box = {{-2.5, -2.5}, {2.5, 2.5}},
	--collision_box = {{-1.4, -1.4}, {1.4, 0.7}},
    --selection_box = {{-1.5, -3}, {1.5, 0.5}},
	collision_box = {{-1.4, -1.4}, {1.4, 1.4}},
	--selection_box = {{-1.4, -3}, {1.4, 1.4}},
	working_sound =
	{
		sound = { filename = "__RealisticReactors__/sound/reactor-active.ogg", volume = 0.6 },
		idle_sound = { filename = "__base__/sound/idle1.ogg", volume = 0.6 },
		apparent_volume = 1.5
	},
    picture =
    {
      layers =
      {
        --{
		--  filename = "__RealisticReactors__/graphics/entity/nuclear-reactor.png",
        --  width = 140,
        --  height = 160,
        --  shift = {0.6875, -0.59375}
        --}
      }
    },
    working_light_picture =
    {
    --  filename = "__RealisticReactors__/graphics/entity/workinglight-yellow.png",
    --  width = 140,
    --  height = 160,
    --  shift = {0.6875, -0.59375},
	--  priority = "extra-high",
    --  blend_mode = "additive"
	  filename = "__RealisticReactors__/graphics/transparent32.png",
      width = 32,
      height = 32,
    },
    --light = {intensity = 2, size = 9.9, shift = {0.0, 0.0}, color = {r = 1.0, g = 0.5, b = 0.0}},
    heat_buffer =
    {
      max_temperature = 1000,
      specific_heat = "5MJ",
      max_transfer = "10GW",
      connections =
      {
        {
          position = {1, -1.5},
          direction = defines.direction.north
        },
        {
          position = {0, -1.5},
          direction = defines.direction.north
        },
        {
          position = {-1, -1.5},
          direction = defines.direction.north
        },
        {
          position = {1, -1},
          direction = defines.direction.east
        },
        {
          position = {1, 0},
          direction = defines.direction.east
        },
        {
          position = {-1.5, 0},
          direction = defines.direction.west
        },
        {
          position = {-1.5, -1},
          direction = defines.direction.west
        }
      }
    },
    connection_patches_connected =
    {
      sheet =
      {
        filename = "__RealisticReactors__/graphics/entity/reactor-connect-patches-empty.png",
        width = 32,
        height = 32,
        variation_count = 12
      }
    },
    connection_patches_disconnected =
    {
      sheet =
      {
        filename = "__RealisticReactors__/graphics/entity/reactor-connect-patches-empty.png",
        width = 32,
        height = 32,
        variation_count = 12,
        y = 32
      }
    },
	--pipe_covers = pipecoverspictures(),
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65},
    meltdown_action = nil
   
  }

  
-- display dummy for normal reactor
reactor_normal=table.deepcopy(reactor_template)
reactor_normal.name = "realistic-reactor-normal"
reactor_normal.flags = {"placeable-neutral", "player-creation"}
reactor_normal.minable = {mining_time = 1.5, result = "realistic-reactor"}
reactor_normal.placeable_by = { item="realistic-reactor", count = 1}
reactor_normal.minable = {mining_time = 1.5, result = "realistic-reactor"}
reactor_normal.consumption = 0.00001 .."W"
reactor_normal.collision_box = {{-1.3, -1.3}, {1.3, 1.4}}
--reactor_normal.selection_box = {{-1.4, -1.9}, {1.4, 0.5}}
reactor_normal.selection_box = {{-1.4, -1.8}, {1.4, 1.35}} --eccs would not be selectable, but interface would.
reactor_normal.selectable_in_game = true
reactor_normal.heat_buffer.connections={}
reactor_normal.light = {intensity = 0.7, size = 9.9, shift = {0.0, 0.0}, color = {r = 0.35, g = 0.8, b = 1.0}}
reactor_normal.picture =
    {
      layers =
      {
        {

		  filename = "__RealisticReactors__/graphics/entity/reactor.png",
          width = 174,
          height = 160,
          shift = {1.2185, -0.59375}
        },
		{
		filename = "__RealisticReactors__/graphics/entity/reactor-shadow.png",
		width = 174,
		height = 160,
		shift = {1.2185, -0.59375},
		draw_as_shadow = true,
		}

      }
    }

 -- display dummy for breeder reactor
reactor_breeder = table.deepcopy(reactor_normal)
reactor_breeder.name = "realistic-reactor-breeder"
reactor_breeder.icon = "__RealisticReactors__/graphics/icons/breeder-reactor.png"
reactor_breeder.minable = {mining_time = 1.5, result = "breeder-reactor"}
reactor_breeder.placeable_by = { item="breeder-reactor", count = 1}
reactor_breeder.picture.layers[1].filename = "__RealisticReactors__/graphics/entity/breeder.png"

reactor_default =  table.deepcopy(reactor_template)
reactor_default.collision_mask = {"item-layer"}

-- Nuclear reactor x, running phase
for i=1, 150 do

local temp_reactor = table.deepcopy(reactor_template)
temp_reactor.name = "realistic-reactor-"..i
temp_reactor.collision_mask = {"item-layer"}
temp_reactor.consumption = i.."MW"
--temp_reactor.light = {intensity = 0.3, size = 9.9, shift = {0.0, 0.0}, color = {r = 0.0, g = 0.5, b = 0.0}}
--temp_reactor.light = {intensity = 0.7, size = 9.9, shift = {0.0, 0.0}, color = {r = 0.35, g = 0.8, b = 1.0}}


data:extend({temp_reactor})

end
 
-- Circuit interface entity for nuclear reactor
reactor_interface =
{
  type = "constant-combinator",
  name = "realistic-reactor-interface",
  collision_mask = {"layer-11"},
  icon = reactor_template.icon,
  icon_size = reactor_template.icon_size,
  order = "f[nuclear-energy]-a[reactor]",
  flags = {"placeable-neutral","placeable-player", "player-creation"},
  minable = {hardness = 0.2, mining_time = 0.5, result = "constant-combinator"},
  placeable_by = {item="constant-combinator", count = 1},
  max_health = reactor_template.max_health,
  collision_box = {{-1.4, -0.25}, {1.4, 0.4}},
  selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
  item_slot_count = 13,

  sprites =
  {
    north =
    {
      filename = "__RealisticReactors__/graphics/entity/nuclear-reactor-interface.png",
      priority = "high",
      frame_count = 1,
      width = 32,
      height = 32,
	  shift = util.by_pixel(1,0)
    },
    east =
    {
      filename = "__RealisticReactors__/graphics/entity/nuclear-reactor-interface.png",
      priority = "high",
      frame_count = 1,
      width = 32,
      height = 32,
	  shift = util.by_pixel(1,0)
    },
    south =
    {
      filename = "__RealisticReactors__/graphics/entity/nuclear-reactor-interface.png",
      priority = "high",
      frame_count = 1,
      width = 32,
      height = 32,
	  shift = util.by_pixel(1,0)
    },
    west =
    {
      filename = "__RealisticReactors__/graphics/entity/nuclear-reactor-interface.png",
      priority = "high",
      frame_count = 1,
      width = 32,
      height = 32,
	  shift = util.by_pixel(1,0)
    }
  },
  activity_led_sprites =
  {
    north = interface_led,
    east = interface_led,
    south = interface_led,
    west = interface_led
  },
  activity_led_light =
  {
    intensity = 0.8,
    size = 1,
  },
  activity_led_light_offsets =
  {
    interface_led.shift,
    interface_led.shift,
    interface_led.shift,
    interface_led.shift
  },
  circuit_wire_connection_points =
  {
    interface_connection,
    interface_connection,
    interface_connection,
    interface_connection
  },
  circuit_wire_max_distance = 7.5,
  order = "z"
}

local breeder_interface = table.deepcopy(reactor_interface)
breeder_interface.name = "realistic-breeder-interface"
breeder_interface.sprites.north.filename = "__RealisticReactors__/graphics/entity/breeder-interface.png"
breeder_interface.sprites.east.filename = "__RealisticReactors__/graphics/entity/breeder-interface.png"
breeder_interface.sprites.south.filename = "__RealisticReactors__/graphics/entity/breeder-interface.png"
breeder_interface.sprites.west.filename = "__RealisticReactors__/graphics/entity/breeder-interface.png"


-- ECCS entity for nuclear reactor
reactor_eccs =
{
  type = "storage-tank",
  name = "realistic-reactor-eccs",
  collision_mask = {"item-layer"},
  icon = reactor_template.icon,
  icon_size = reactor_template.icon_size,
  order = "f[nuclear-energy]-a[reactor]",
  flags = {"player-creation", "not-deconstructable","not-blueprintable"},
  --placeable_by = {item="iron-plate", count = 1},
  max_health = reactor_template.max_health,
  collision_mask = {"ghost-layer"},
  collision_box = {{-1.3, -1.3}, {1.3, 1.3}},
  selection_box = {{-1.4,0.5},{1.4,1.7}},
  --drawing_box = {{-1.4,-1.4},{-1,-1}}, --doesnt affect alt-info-overlay
  fluid_box =
  {
    base_area = 50,
    pipe_covers = pipecoverspictures(),
    pipe_connections =
    {
      --{position = {-2, -1}},
      {position = {-2, 1}},
      --{position = {-1, -2}},
      {position = {-1, 2}},
      --{position = {1, -2}},
      {position = {1, 2}},
      --{position = {2, -1}},
      {position = {2, 1}}
    }
  },
  window_bounding_box = {{-0.1,-0.1}, {0.1,0.1}},
  pictures =
  {
    picture =
    {
      north = empty_sprite,
      east = empty_sprite,
      south = empty_sprite,
      west = empty_sprite
    },
    fluid_background = empty_sprite,
    window_background = empty_sprite,
    flow_sprite = empty_sprite,
	gas_flow = empty_sprite
  },
  flow_length_in_ticks = 360,
  --circuit_wire_connection_points = reactor_interface.circuit_wire_connection_points,
  circuit_wire_connection_points = {
{
  shadow =
  {
    red = {-0.896875, 1.5},
    green = {-1.403125, 1.5},
  },
  wire =
  {
    red = {-1.296875, 1.0625},
    green = {-1.696875, 1.0625},
  }
},
{
  shadow =
  {
    red = {-0.896875, 1.5},
    green = {-1.403125, 1.5},
  },
  wire =
  {
    red = {-1.296875, 1.0625},
    green = {-1.696875, 1.0625},
  }
},
{
  shadow =
  {
    red = {-0.896875, 1.5},
    green = {-1.403125, 1.5},
  },
  wire =
  {
    red = {-1.296875, 1.0625},
    green = {-1.696875, 1.0625},
  }
},
{
  shadow =
  {
    red = {-0.896875, 1.5},
    green = {-1.403125, 1.5},
  },
  wire =
  {
    red = {-1.296875, 1.0625},
    green = {-1.696875, 1.0625},
  }
},

},
  circuit_wire_max_distance = 5,
  order = "z",
  --circuit_wire_connection_points = circuit_connector_definitions["storage-tank"].points,
  circuit_connector_sprites = circuit_connector_definitions["storage-tank"].sprites,
  --  circuit_wire_max_distance = default_circuit_wire_max_distance,
}

-- Power draining entity for normal reactor
reactor_power_normal =
  {
    type = "electric-energy-interface",
    name = "realistic-reactor-power-normal",
	icon = reactor_normal.icon,
	icon_size = reactor_normal.icon_size,
    flags = {"player-creation", "not-deconstructable","not-blueprintable"},
	order = "f[nuclear-energy]-a[reactor]",
    max_health = 150,
	collision_mask = {"ghost-layer"},
    collision_box = {{-1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{-1.4, -1.4}, {1.4, 1.4}},
    drawing_box = {{-0.5, -2.5}, {0.5, 0.3}},
	selectable_in_game = false,
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
	  input_flow_limit= "17MW",
	  buffer_capacity = "17MJ"
    },
	energy_production = "0kW",
	energy_usage = "0kW",
  }

-- Power draining entity 2 for nuclear reactor
reactor_power_breeder =table.deepcopy(reactor_power_normal)
reactor_power_breeder.name = "realistic-reactor-power-breeder"
reactor_power_breeder.icon = reactor_breeder.icon
reactor_power_breeder.icon_size = reactor_breeder.icon_size


-- Cooling tower
cooling_tower =
{
  type = "furnace",
  name = "rr-cooling-tower",
  icon = "__RealisticReactors__/graphics/icons/cooling-tower.png",
  icon_size = 32,
  flags = {"placeable-neutral", "placeable-player", "player-creation"},
  minable = {hardness = 0.2, mining_time = 0.5, result = "rr-cooling-tower"},
  max_health = 500,
  corpse = "medium-remnants",
  resistances =
  {
    {
      type = "fire",
      percent = 70
    }
  },
  collision_box = {{-1.3, -1.3}, {1.3, 1.3}},
  selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
  drawing_box = {{-1.5, -3}, {1.5, 1.5}},
  fluid_boxes =
  {
    {
      production_type = "input",
      base_area = 25,
      base_level = -1,
      pipe_covers = pipecoverspictures(),
      pipe_connections =
      {
        {position = {-2, -1}},
        {position = {-2, 1}},
        {position = {-1, -2}},
        {position = {-1, 2}}
      }
    },
    {
      production_type = "output",
      base_area = 25,
      base_level = 1,
      pipe_covers = pipecoverspictures(),
      pipe_connections =
      {
        {position = {1, -2}},
        {position = {1, 2}},
        {position = {2, -1}},
        {position = {2, 1}}
      }
    }
  },
  source_inventory_size = 0,
  result_inventory_size = 0,
  crafting_categories = {"water-cooling"},
  energy_usage = "120kW",
  crafting_speed = 1,
  energy_source =
  {
    type = "electric",
    usage_priority = "primary-input",
    emissions = 0,
  },
  animation =
  { layers={{
    filename = "__RealisticReactors__/graphics/entity/cooling-tower.png",
    width = 140,
    height = 160,
    frame_count = 1,
    shift = {0.6875, -0.59375},
	hr_version =
		{
		filename = "__RealisticReactors__/graphics/entity/cooling-tower-hr.png",
		width = 308,
		height = 310,
		frame_count = 1,
		shift = {0.695, -0.66},
		scale = 0.505
		}
	},
    {
      filename = "__RealisticReactors__/graphics/entity/cooling-tower-hr-shadow.png",
      width = 308,
      height = 310,
      frame_count = 1,
      shift = {0.695, -0.66},
	  scale = 0.505,
      draw_as_shadow = true,
    }
  }}
}

-- Steam creator for cooling tower
cooling_tower_steam =
{
  type = "furnace",
  name = "rr-cooling-tower-steam",
  icon = cooling_tower.icon,
  icon_size = 32,
  order = "f[nuclear-energy]-a[reactor]",
  flags = {"not-blueprintable", "not-deconstructable"},
  max_health = cooling_tower.max_health,
  collision_mask = {"ghost-layer"},
  collision_box = {{-0.5,-0.5},{0.5,0.5}},
  selection_box = {{-0.5,-0.5},{0.5,0.5}},
  fluid_boxes =
  {
    {
      production_type = "input",
      base_area = 0.1,
      pipe_connections = { }
    },
    {
      production_type = "output",
      base_area = 0.1,
      pipe_connections = { }
    }
  },
  source_inventory_size = 0,
  result_inventory_size = 0,
  crafting_categories = {"steaming"},
  energy_usage = "1W",
  crafting_speed = 1,
  energy_source =
  {
    type = "burner",
    effectivity = 1,
    fuel_inventory_size = 1,
    emissions = 0,
    light_flicker =
    {
      minimum_intensity = 0,
      maximum_intensity = 0
    },
    smoke =
    {
      {
        name = "turbine-smoke",
		type = "trivial-smoke",
        deviation = {0.1, 0.1},
        frequency = 10,
        position = {0.0, -2.25},
        starting_vertical_speed = 0.00,
        starting_frame_deviation = 60,
		color = {r = 0.8, g = 0.8, b = 0.8, a = 0.1},
		duration = 150,
		spread_duration = 100,
		fade_away_duration = 100,
		start_scale = 1.25,
		end_scale = 2.0,
		affected_by_wind = true
      }
    }
  },
  animation = empty_sprite
}

data:extend({ 
  reactor_default,
  reactor_interface,
  breeder_interface,
  reactor_eccs,
  reactor_power_normal,
  reactor_power_breeder,
  reactor_normal,
  reactor_breeder,
  cooling_tower,
  cooling_tower_steam,
})