red_light = {
    type = "lamp",
    name = "rr-red-light",
	order = "z",
	alert_icon_scale =0,
    icon = "__RealisticReactors__/graphics/lamps/red.png",
    icon_size = 32,
	collision_mask={"item-layer"},
    flags = {"placeable-neutral", "player-creation", "placeable-off-grid","not-deconstructable"},
    max_health = 100,
    corpse = "small-remnants",
    --collision_box = {{-1.4, -1.9}, {1.4, 1.4}}, +0,62 -0,6
    collision_box = {{-0.78, -2.1}, {2.02, 0.8}},
    --selection_box = {{-0.78, -2.1}, {2.02, 0.8}},
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    energy_source ={
      type = "electric",
      usage_priority = "lamp",
	  render_no_power_icon =  false ,
      render_no_network_icon = false,},
    energy_usage_per_tick = "5KW",
    darkness_for_all_lamps_on = 0.00001,
    darkness_for_all_lamps_off = 0,
    light = {intensity = 0.6, size = 3, color = {r=1.0, g=0.0, b=0.0}},
    light_when_colored = {intensity = 1, size = 6, color = {r=1.0, g=1.0, b=1.0}},
    glow_size = 2,
    glow_color_intensity = 0.135,
    picture_off =
    {
      layers =
      {
        {
          filename = "__RealisticReactors__/graphics/transparent32.png",
          priority = "high",
          width = 32,
          height = 32,
          frame_count = 1,
          axially_symmetrical = false,
          direction_count = 1,
		  --shift = {-0.62, 0.6}
        },
      }
    },
    picture_on =
    {
      filename = "__RealisticReactors__/graphics/transparent32.png",
      priority = "high",
      width = 32,
      height = 32,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
    },
  }-----------------------------------------------------------------------------------------------------------------------------------------------
red_lamp =   {
    type = "simple-entity-with-force",
    name = "rr-red-lamp",
	flags = {"placeable-neutral", "player-creation", "placeable-off-grid","not-deconstructable"},
    render_layer = "object",
	collision_mask={"item-layer"},
    icon = "__base__/graphics/icons/steel-chest.png",
    icon_size = 32,
    order = "s-e-w-f",
    max_health = 100,
    corpse = "small-remnants",
    picture =
    {
      filename = "__RealisticReactors__/graphics/lamps/red.png",
      priority = "extra-high",
      width = 32,
      height = 32,
	  --shift = {-0.5, -0.5}
    }
  }
yellow_light = table.deepcopy(red_light)
yellow_light.name="rr-yellow-light"
yellow_light.light = {intensity = 0.6, size = 3, color = {r=1.0, g=1.0, b=0.0}}
yellow_light.icon = "__RealisticReactors__/graphics/lamps/yellow.png"

yellow_lamp = table.deepcopy(red_lamp)
yellow_lamp.name="rr-yellow-lamp"
yellow_lamp.picture.filename = "__RealisticReactors__/graphics/lamps/yellow.png"



green_light = table.deepcopy(red_light)
green_light.name="rr-green-light"
green_light.light = {intensity = 0.6, size = 3, color = {r=0.0, g=1.0, b=0.0}}
green_light.icon = "__RealisticReactors__/graphics/lamps/green.png"

green_lamp = table.deepcopy(red_lamp)
green_lamp.name="rr-green-lamp"
green_lamp.picture.filename = "__RealisticReactors__/graphics/lamps/green.png"



black_light = table.deepcopy(red_light)
black_light.name="rr-black-light"
black_light.light = {intensity = 0.1, size = 3, color = {r=0.1, g=0.1, b=0.1}}
black_light.icon = "__RealisticReactors__/graphics/lamps/black.png"

black_lamp = table.deepcopy(red_lamp)
black_lamp.name="rr-black-lamp"
black_lamp.picture.filename = "__RealisticReactors__/graphics/lamps/black.png"


data:extend({
red_light,
red_lamp,
yellow_light,
yellow_lamp,
green_light,
green_lamp,
black_light,
black_lamp,
  })