--copyright ownlyme, written for realistic reactors (free to use/distribute/edit/build upon as a module of this mod or other mods by ingoknieto)



COLUMN_COUNT = 70
PIXEL_WIDTH = 2
FONT_SIZE = 12

function splitty(s,delimiter) 
    result = {} 
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do 
        table.insert(result, match) 
    end 
    return tonumber(result[1]), tonumber(result[2])
end

function gui_init()
global.worker_key = nil
global.gui_count = 0
global.stats = {}
global.guis = {}
end

function string2color(ryba)
local color = {r=0,g=0,b=0}
if ryba == "r" then
	color.r=1
end	
if ryba == "y" then
	color.r=1
	color.g=1
end
if ryba == "b" then
	color.b=1
end	
if ryba == "a" then
	color.r=0.4
	color.g=0.75
	color.b=1
end
if ryba == "ry" then
	color.r=1
	color.g=0.5
end	
if ryba == "rb" then
	color.r=1
	color.b=1
end	
if ryba == "ra" then
	color.r=1
	color.g=0.75
	color.b=1
end	
if ryba == "yb" then
	color.g=1
end
if ryba == "ya" then
	color.r=0.5
	color.g=0.85
	color.b=0.85
end
if ryba == "ba" then
	color.r=0.70
	color.g=0.80
	color.b=0.80
end
if ryba == "ryb" then
	color.r=0.9
	color.g=0.9
	color.b=0.9
end
if ryba == "rba" then
	color.r=0.67
	color.g=0.61
	color.b=0.78
end
if ryba == "yba" then
	color.r=0.62
	color.g=0.8
	color.b=0.79
end
if ryba == "ryba" then
	color.r=1
	color.g=1
	color.b=1
end
return color
end


function stats_tick(event)
if event.tick% (TICKS_PER_UPDATE*2) == 0 then

	--if not global.stats[reactor_key] then global.stats[reactor_key] = {efficiency = {},production = {},temperature = {}, aqua = {}} end
	for reactor_key, stats in pairs (global.stats) do
		if not global.reactors[reactor_key] then
			global.stats[reactor_key]=nil
		else
			signals = global.reactors[reactor_key].signals.parameters
			if global.reactors[reactor_key].power_usage.interface >1 then
				stats.efficiency[COLUMN_COUNT] = math.min(100,math.max(1,math.floor((signals["efficiency"].count or 1)/2)))
				stats.production[COLUMN_COUNT] = math.min(100,math.max(1,math.floor((signals["power-output"].count or 1)/2)))
				stats.temperature[COLUMN_COUNT] = math.min(100,math.max(1,math.floor((signals["core_temperature"].count or 1)/10)))
				stats.aqua[COLUMN_COUNT] = math.min(100,math.max(1,math.floor(global.reactors[reactor_key].cooling_history/2)))
			else
				stats.efficiency[COLUMN_COUNT] = -1
				stats.production[COLUMN_COUNT] = -1
				stats.temperature[COLUMN_COUNT] =-1
				stats.aqua[COLUMN_COUNT] =-1
				
			end
			--local cooling = 0
			--for i=1,math.floor(1/(TICKS_PER_UPDATE/30)) do
			--	cooling = cooling + global.reactors[reactor_key].cooling_history[i]
			--end
			--stats.aqua[COLUMN_COUNT] = math.floor(cooling / math.floor(1/(TICKS_PER_UPDATE/30))/2)
			
			--game.players[1].print(stats.aqua[COLUMN_COUNT])
			for k=1,COLUMN_COUNT-1 do

				stats.efficiency[k] = stats.efficiency[k+1]
				stats.production[k] = stats.production[k+1]
				stats.temperature[k] = stats.temperature[k+1]
				stats.aqua[k]=stats.aqua[k+1]
			end
		end
	end
end
if event.tick % TICKS_PER_UPDATE == 0 then
	for key, gui in pairs (global.guis) do
		local reactor_key, playerid = splitty(key,"-")

		local reactor = global.reactors[reactor_key]

		if reactor and reactor.displayer.valid and global.stats[reactor_key] then
			local signals = reactor.signals.parameters
			if gui.signals then
				gui.signals.temperature.number=math.floor(signals["core_temperature"].count)
				gui.signals.power.number=math.floor(signals["power-output"].count)
				gui.signals.efficiency.number=math.floor(signals["efficiency"].count)
				if reactor.displayer.name == "realistic-reactor-breeder" then
					gui.signals.bonuscells.number=math.floor(signals["cell-bonus"].count)/100
				end
				gui.signals.coolant.number=signals["coolant-amount"].count
				if signals["state_stopped"].count > 0 then
					gui.signals.status.number=signals["state_stopped"].count
					gui.signals.status.sprite="virtual-signal/signal-state-stopped"
				elseif signals["state_starting"].count > 0 then
					gui.signals.status.number=signals["state_starting"].count
					gui.signals.status.sprite="virtual-signal/signal-state-starting"
				elseif signals["state_running"].count > 0 then
					gui.signals.status.number=signals["state_running"].count
					gui.signals.status.sprite="virtual-signal/signal-state-running"
				elseif signals["state_scramed"].count > 0 then
					gui.signals.status.number=signals["state_scramed"].count
					gui.signals.status.sprite="virtual-signal/signal-state-scramed"
				end
			end
			if gui.progress then
				if reactor.displayer.get_fuel_inventory().is_empty() then
					gui.progress.cells.number = 0
					gui.progress.cells.sprite = "rr-transparent-sprite"
				else
					gui.progress.cells.number = reactor.displayer.get_fuel_inventory()[1].count
					gui.progress.cells.sprite = "item/"..reactor.displayer.get_fuel_inventory()[1].name
				end
				
				if reactor.displayer.get_burnt_result_inventory().is_empty() then
					gui.progress.used_cells.number = 0
					gui.progress.used_cells.sprite = "rr-transparent-sprite"
				else
					gui.progress.used_cells.number = reactor.displayer.get_burnt_result_inventory()[1].count
					gui.progress.used_cells.sprite = "item/"..reactor.displayer.get_burnt_result_inventory()[1].name
				end
				
				if reactor.core.burner.currently_burning == nil then
					gui.progress.bars.progress.value=0
					if reactor.displayer.name == "realistic-reactor-breeder" then
						gui.progress.bars.bonus_cells.value=0
					end
				else
					local burnt_result = reactor.core.burner.currently_burning.burnt_result
					--gui.progress.cells.sprite = "item/"..reactor.core.burner.currently_burning.name
					--gui.progress.used_cells.sprite = "item/"..burnt_result.name
					gui.progress.bars.progress.value = reactor.core.burner.remaining_burning_fuel / reactor.core.burner.currently_burning.fuel_value 
					
					if reactor.displayer.name == "realistic-reactor-breeder" then
						gui.progress.bars.bonus_cells.value = math.min(1,reactor.bonus_cells[burnt_result.name] or 0)
					end
				end
			end
		else
			global.stats[reactor_key] = nil
			gui.destroy()
			global.guis[reactor_key.."-"..playerid] = nil
			global.gui_count = global.gui_count - 1
		
		end
	end
end
--process graphs
if event.tick % math.floor((TICKS_PER_UPDATE*2) / global.gui_count) ==0 then
	global.worker_key = next(global.guis, global.worker_key)
	if global.worker_key == nil then
		global.worker_key = next(global.guis, global.worker_key)
	end
	local graphs_processed=0
	while global.worker_key and graphs_processed<1 do
		local gui = global.guis[global.worker_key]
		if gui.graph then
			local reactor_key,playerid = splitty(global.worker_key,"-")
			if not global.reactors[reactor_key] or not global.stats[reactor_key] then
				global.stats[reactor_key] = nil
				gui.destroy()
				global.guis[reactor_key.."-"..playerid] = nil
				global.gui_count = global.gui_count - 1
			else
				if gui.graph.valid then
					local stats=global.stats[reactor_key]
					for k, temperature in pairs(stats.temperature) do
						local colors={}

						colors[stats.production[k]] = ""
						colors[stats.efficiency[k]] = ""
						colors[stats.aqua[k]] = ""
						colors[stats.production[k]+1] = ""
						colors[stats.efficiency[k]+1] = ""
						colors[stats.aqua[k]+1] = ""
						
						colors[stats.temperature[k]] = "r"
						colors[stats.temperature[k]+1] = "r"
						colors[stats.production[k]] = colors[stats.production[k]] .."y"
						colors[stats.production[k]+1] = colors[stats.production[k]+1] .."y"
						colors[stats.efficiency[k]] = colors[stats.efficiency[k]] .."b"
						colors[stats.efficiency[k]+1] = colors[stats.efficiency[k]+1] .."b"
						colors[stats.aqua[k]] = colors[stats.aqua[k]].."a"
						colors[stats.aqua[k]+1] = colors[stats.aqua[k]+1].."a"
						
						local height = 0
						local counter = 1
						local value,color = next(colors)

						while value do
							if value >0 then
								if counter > 1 then
									gui.graph.table["col_".. k]["space_"..counter-1].style.minimal_height=math.max(0,value-height)
								end
								height=value+2
								gui.graph.table["col_".. k]["dot_"..counter.."_1"].style.color=string2color(color)
								if colors[value+1] then
									gui.graph.table["col_".. k]["dot_"..counter.."_2"].style.color=string2color(colors[value+1])
									value,color = next(colors,value)
								else
									gui.graph.table["col_".. k]["dot_"..counter.."_2"].style.color={r=0,g=0,b=0}
								end
								counter=counter+1
							end
							value,color = next(colors,value)
						end
						for i=counter,4 do

							gui.graph.table["col_".. k]["space_"..i-1].style.minimal_height=0
							gui.graph.table["col_".. k]["dot_"..i.."_1"].style.color={r=0,g=0,b=0}
							gui.graph.table["col_".. k]["dot_"..i.."_2"].style.color={r=0,g=0,b=0}
							height=height+2
							
						end
						gui.graph.table["col_".. k]["space_".. 4].style.minimal_height=100-height												
					end
					local temp_stats = {}
					local signals = global.reactors[reactor_key].signals.parameters
					

					freespot = 0
					while temp_stats[math.min(100,stats.production[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] do
						freespot = freespot + 1
					end
					temp_stats[math.min(100,stats.production[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] = "y"
					--game.players[1].print(game.tick.." y = "..stats.production[COLUMN_COUNT])
					
					freespot = 0
					while temp_stats[math.min(100,stats.efficiency[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] do
						freespot = freespot + 1
					end
					temp_stats[math.min(100,stats.efficiency[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] = "b"
					--game.players[1].print(game.tick.." b = "..stats.efficiency[COLUMN_COUNT])
					
					freespot = 0
					while temp_stats[math.min(100,stats.aqua[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] do
						freespot = freespot + 1
					end
					temp_stats[math.min(100,stats.aqua[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] = "a"
					--game.players[1].print(game.tick.." a = "..stats.aqua[COLUMN_COUNT])
					
					freespot = 0
					while temp_stats[math.min(100,stats.temperature[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] do
						freespot = freespot + 1
					end
					temp_stats[math.min(100,stats.temperature[COLUMN_COUNT]+math.floor(FONT_SIZE/2))+freespot] = "r"
					--game.players[1].print(game.tick.." r = "..stats.temperature[COLUMN_COUNT])
					
					--local checked_stats = {}
					local groups = {}
					local i = 1
					
					local currentvalue = next(temp_stats, nil)
					while currentvalue do
						groups[i] = {min_value = currentvalue, max_value = currentvalue, avg_value = currentvalue, count = 1, values = {}}
						groups[i].values[currentvalue] = temp_stats[currentvalue]
						local nextvalue = next(temp_stats,currentvalue)
						local values = 1
						--game.players[1].print(game.tick.." group "..i.." "..currentvalue.." = "..temp_stats[currentvalue])    --
						--if nextvalue then                                                  --
						--	game.players[1].print(game.tick..i.." next: "..nextvalue)      --
						--end                                                                --
						--game.players[1].print(i.." "..nextvalue - groups[i].min_value)
						--if nextvalue and nextvalue - groups[i].min_value < 10 * groups[i].count then
						--	game.players[1].print(game.tick.."GROUP: ")
						--end
						while nextvalue and nextvalue - groups[i].min_value < FONT_SIZE * groups[i].count do
							groups[i].count = groups[i].count + 1
							groups[i].values[nextvalue] = temp_stats[nextvalue]
							--game.players[1].print (game.tick.." "..groups[i].count..": "..nextvalue .." = "..temp_stats[nextvalue])
							local values_sum = 0
							for value, stat in pairs(groups[i].values) do
								values_sum = values_sum + value
							end
							
							groups[i].avg_value = values_sum / groups[i].count
							groups[i].min_value = values_sum / groups[i].count - math.floor(FONT_SIZE/2) * (groups[i].count-1)
							groups[i].max_value = values_sum / groups[i].count + math.floor(FONT_SIZE/2) * (groups[i].count-1)
							if groups[i].min_value < 1 then
								groups[i].max_value = groups[i].max_value + (1 - groups[i].min_value)
								groups[i].min_value = 1
							end
							if groups[i].max_value > 100 then
								groups[i].min_value = groups[i].min_value - (groups[i].max_value - 100)
								groups[i].max_value = 100
							end
							nextvalue = next(temp_stats,nextvalue)
						end
						
						if nextvalue then
							currentvalue = nextvalue
							i=i+1
						else
							currentvalue = nil
						end
					end
					
					local last_maximal = 0
					for key, group in pairs(groups) do
						if group.min_value < last_maximal+FONT_SIZE then
							group.min_value = group.min_value + last_maximal - group.min_value+FONT_SIZE
							group.max_value = group.max_value + last_maximal - group.min_value+FONT_SIZE
						end
						last_maximal = group.max_value
					end
					
					local last_minimal = 100+FONT_SIZE
					for key=i, 1, -1 do
						local group = groups[key]
						if group.max_value > last_minimal-FONT_SIZE then
							group.min_value = group.min_value - (group.max_value - (last_minimal-FONT_SIZE))
							group.max_value = group.max_value - (group.max_value - (last_minimal-FONT_SIZE))
						end
						last_minimal = group.min_value
					end
					
					local temp_stats2 = {}
					for key, group in pairs(groups) do
						i = 0
						for _, stat in pairs(group.values) do
							--if temp_stats2[math.floor(group.min_value + i*12)] then
							--	game.players[1].print(i.."occupied")
							--end
							table.insert(temp_stats2,{value = math.floor(group.min_value + i*FONT_SIZE), stat = stat})
							--game.players[1].print(game.tick.." ("..i..") "..math.floor(group.min_value + i*FONT_SIZE).." = "..stat)
							i = i+1
						end
					end
					local height = 100
					--for value,stat in pairs(temp_stats2) do
					for counter = 4, 1, -1 do
						local value = temp_stats2[counter].value
						local stat = temp_stats2[counter].stat

						gui.graph.table["col_".. COLUMN_COUNT+1]["space_"..counter].style.height=math.max(0,height-value-1)

						--game.players[1].print(game.tick.." spacer "..counter.." = "..gui.graph.table["col_".. COLUMN_COUNT+1]["space_"..counter].style.minimal_height.."px, value = "..value)
						height=height-math.max(0,height-value-1)-FONT_SIZE
						--game.players[1].print(game.tick .." height:"..height-16 .." value:"..value.." color:"..stat)
						if global.reactors[reactor_key].power_usage.interface >1 then
							if stat=="r" then
								gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].caption = "  "..math.floor(signals["core_temperature"].count).."°"
							elseif stat=="y" then
								gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].caption = "  "..signals["power-output"].count.."MW"
							elseif stat=="b" then
								gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].caption = "  "..signals["efficiency"].count.."%"
							else
								gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].caption = math.floor(global.reactors[reactor_key].cooling_history)*-1 .."MW"
							end
							gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].style.font_color = string2color(stat)
						else
							gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].caption = ""
							gui.graph.table["col_".. COLUMN_COUNT+1]["text_"..counter].style.font_color = {r=0,g=0,b=0}
						end
					end
					--gui.graph.table["col_".. COLUMN_COUNT+1]["space_".. 5].style.height= 0 --height
					--game.players[1].print(game.tick.." spacer 5 = "..gui.graph.table["col_".. COLUMN_COUNT+1]["space_5"].style.minimal_height.."px")
					--game.players[1].print(100-height)
				end
			end
			graphs_processed=graphs_processed+1
		else				
			global.worker_key = next(global.guis, global.worker_key)
		end
	end	
		


end
end

script.on_event(defines.events.on_gui_opened, function(event)
  local player = game.players[event.player_index]
  if player.opened_gui_type ~= defines.gui_type.entity then return end
  local entity = player.opened
  if entity ~= nil and (entity.name == "realistic-reactor-interface" or entity.name == "realistic-breeder-interface") then
	local reactor_key
	for key, reactor in pairs(global.reactors) do
		if reactor.interface == player.opened then
			reactor_key = key
		end
	end
    player.opened = nil
	if reactor_key then
		if player.gui.left["rr_gui_"..reactor_key] then
			player.gui.left["rr_gui_"..reactor_key].destroy()
			global.guis[reactor_key.."-"..event.player_index]=nil
			global.gui_count = global.gui_count -1
		else
			create_gui(player,reactor_key)
		end
	end
  end
end)

script.on_event(defines.events.on_gui_click, function(event)
	local element = event.element
	
	if not element.parent or element.parent.name ~="rr_buttons_flow" then return end
	local reactor_key = tonumber(string.sub(element.parent.parent.name,8))
	if (not global.reactors[reactor_key]) or element.name == "rr_button_exit" then
		global.guis[reactor_key.."-"..event.player_index]=nil
		global.gui_count = global.gui_count -1
		element.parent.parent.destroy()
		
	elseif element.name == "rr_button_signals" then
		if element.parent.parent.signals then
			element.parent.parent.signals.destroy()
			element.parent.rr_button_signals.sprite = "rr-button-signals-off"
		else
			create_signals(element.parent.parent,reactor_key)
			element.parent.rr_button_signals.sprite = "rr-button-signals"
		end
	
	elseif element.name == "rr_button_progress" then
		if element.parent.parent.progress then
			element.parent.parent.progress.destroy()
			element.parent.rr_button_progress.sprite = "rr-button-progress-off"
		else
			create_progress(element.parent.parent,reactor_key)
			element.parent.rr_button_progress.sprite = "rr-button-progress"
		end
	
	elseif element.name == "rr_button_graph" then
		if element.parent.parent.graph then
			element.parent.parent.graph.destroy()
			element.parent.rr_button_graph.sprite = "rr-button-graph-off"
		else
			create_graph(element.parent.parent)
			element.parent.rr_button_graph.sprite = "rr-button-graph"
		end

	end
end)
	
function create_gui(player, reactor_key)
	local reactor = global.reactors[reactor_key]
	local gui = player.gui.left.add{type = "frame", name = "rr_gui_"..reactor_key, caption = "", direction = "vertical"}
	if not global.stats[reactor_key] then 
		global.stats[reactor_key] = {}
		global.stats[reactor_key].temperature = {}
		global.stats[reactor_key].efficiency = {}
		global.stats[reactor_key].production = {}
		global.stats[reactor_key].aqua = {}
	end
	gui.add{type = "table", column_count = 4, name = "rr_buttons_flow", direction = "horizontal"}
	gui.rr_buttons_flow.style.top_padding 		= 0
	gui.rr_buttons_flow.style.right_padding 	= 0
	gui.rr_buttons_flow.style.bottom_padding 	= 0
	gui.rr_buttons_flow.style.left_padding 		= 0
	gui.rr_buttons_flow.style.horizontal_spacing= 5
	gui.rr_buttons_flow.style.scaleable = false
	
		gui.rr_buttons_flow.add{type = "sprite-button",name = "rr_button_signals", sprite = "rr-button-signals"}
		gui.rr_buttons_flow.rr_button_signals.style.top_padding 	= 0
		gui.rr_buttons_flow.rr_button_signals.style.right_padding 	= 0
		gui.rr_buttons_flow.rr_button_signals.style.bottom_padding 	= 0
		gui.rr_buttons_flow.rr_button_signals.style.left_padding 	= 0	
		gui.rr_buttons_flow.rr_button_signals.style.height 	= 25
		gui.rr_buttons_flow.rr_button_signals.style.width 	= 62
		gui.rr_buttons_flow.rr_button_signals.style.scaleable = false
		
		gui.rr_buttons_flow.add{type = "sprite-button",name = "rr_button_progress", sprite = "rr-button-progress"}
		gui.rr_buttons_flow.rr_button_progress.style.top_padding 		= 0
		gui.rr_buttons_flow.rr_button_progress.style.right_padding 		= 0
		gui.rr_buttons_flow.rr_button_progress.style.bottom_padding 	= 0
		gui.rr_buttons_flow.rr_button_progress.style.left_padding 		= 0	
		gui.rr_buttons_flow.rr_button_progress.style.height 	= 25
		gui.rr_buttons_flow.rr_button_progress.style.width 		= 43
		gui.rr_buttons_flow.rr_button_progress.style.scaleable = false
		
		gui.rr_buttons_flow.add{type = "sprite-button",name = "rr_button_graph", sprite = "rr-button-graph-off"}
		gui.rr_buttons_flow.rr_button_graph.style.top_padding 		= 0
		gui.rr_buttons_flow.rr_button_graph.style.right_padding 	= 0
		gui.rr_buttons_flow.rr_button_graph.style.bottom_padding 	= 0
		gui.rr_buttons_flow.rr_button_graph.style.left_padding 		= 0	
		gui.rr_buttons_flow.rr_button_graph.style.height 		= 25
		gui.rr_buttons_flow.rr_button_graph.style.width 		= 43
		gui.rr_buttons_flow.rr_button_graph.style.scaleable = false
		
		gui.rr_buttons_flow.add{type = "sprite-button",name = "rr_button_exit", sprite = "rr-button-x"}
		gui.rr_buttons_flow.rr_button_exit.style.top_padding 		= 0
		gui.rr_buttons_flow.rr_button_exit.style.right_padding 		= 0
		gui.rr_buttons_flow.rr_button_exit.style.bottom_padding 	= 0
		gui.rr_buttons_flow.rr_button_exit.style.left_padding 		= 0	
		gui.rr_buttons_flow.rr_button_exit.style.height 	= 25
		gui.rr_buttons_flow.rr_button_exit.style.width 		= 26
		gui.rr_buttons_flow.rr_button_exit.style.scaleable = false
	
	create_signals(gui,reactor_key)
	create_progress(gui,reactor_key)
	
	global.gui_count = global.gui_count + 1
	global.guis[reactor_key.."-"..player.index] = gui
	
end


function create_graph(gui)

	gui.add{type = "sprite", name = "graph", sprite="rr-black-background", direction = "vertical"}
	gui.graph.style.maximal_width=math.floor(80*PIXEL_WIDTH)+32
	gui.graph.style.maximal_height=100
	gui.graph.style.scaleable = false
	gui.graph.add{type = "table", column_count=COLUMN_COUNT+1, name = "table", direction = "vertical"}
	gui.graph.table.style.horizontal_spacing=0
	gui.graph.table.style.vertical_spacing=0
	gui.graph.table.style.scaleable = false
	
	for x=1,COLUMN_COUNT+1 do
		gui.graph.table.add{type = "table", column_count=1, name = "col_"..x, direction = "vertical"}
		gui.graph.table["col_"..x].style.horizontal_spacing=0
		gui.graph.table["col_"..x].style.vertical_spacing=0
		gui.graph.table["col_"..x].style.minimal_height=100
		gui.graph.table["col_"..x].style.maximal_height=100
		gui.graph.table["col_"..x].style.scaleable = false
		if x>COLUMN_COUNT then
		gui.graph.table["col_"..x].style.left_padding = 3
		end
		--gui.graph.table["col_"..x].add{type = "flow", name = "space_5", direction = "vertical"}
		--gui.graph.table["col_"..x]["space_5"].style.maximal_height=100
		--gui.graph.table["col_"..x]["space_5"].style.minimal_height=1
		--gui.graph.table["col_"..x]["space_5"].style.maximal_width=PIXEL_WIDTH
		--gui.graph.table["col_"..x]["space_5"].style.minimal_width=PIXEL_WIDTH
		--gui.graph.table["col_"..x]["space_5"].style.scaleable = false
		
	end
	for x=1,COLUMN_COUNT+1 do
		for y=4,1,-1 do
			gui.graph.table["col_"..x].add{type = "flow", name = "space_"..y, direction = "vertical"}
			gui.graph.table["col_"..x]["space_"..y].style.maximal_height=100
			gui.graph.table["col_"..x]["space_"..y].style.minimal_height=1
			gui.graph.table["col_"..x]["space_"..y].style.maximal_width=PIXEL_WIDTH
			gui.graph.table["col_"..x]["space_"..y].style.minimal_width=PIXEL_WIDTH
			gui.graph.table["col_"..x]["space_"..y].style.scaleable = false
			if x <=COLUMN_COUNT then
				gui.graph.table["col_"..x].add{type = "progressbar", name = "dot_"..y.."_2", direction = "vertical"}
				gui.graph.table["col_"..x]["dot_"..y.."_2"].style.maximal_height=1
				gui.graph.table["col_"..x]["dot_"..y.."_2"].style.maximal_width=PIXEL_WIDTH
				gui.graph.table["col_"..x]["dot_"..y.."_2"].style.minimal_width=PIXEL_WIDTH
				gui.graph.table["col_"..x]["dot_"..y.."_2"].value=1
				gui.graph.table["col_"..x]["dot_"..y.."_2"].style.color={r=0,g=0,b=0}
				gui.graph.table["col_"..x]["dot_"..y.."_2"].style.scaleable = false
				
				gui.graph.table["col_"..x].add{type = "progressbar", name = "dot_"..y.."_1", direction = "vertical"}
				gui.graph.table["col_"..x]["dot_"..y.."_1"].style.maximal_height=1
				gui.graph.table["col_"..x]["dot_"..y.."_1"].style.maximal_width=PIXEL_WIDTH
				gui.graph.table["col_"..x]["dot_"..y.."_1"].style.minimal_width=PIXEL_WIDTH
				gui.graph.table["col_"..x]["dot_"..y.."_1"].value=1
				gui.graph.table["col_"..x]["dot_"..y.."_1"].style.color={r=0,g=0,b=0}
				gui.graph.table["col_"..x]["dot_"..y.."_1"].style.scaleable = false
			else
				gui.graph.table["col_"..x].add{type = "label", name = "text_"..y, direction = "vertical"}
				gui.graph.table["col_"..x]["text_"..y].caption = ""
				gui.graph.table["col_"..x]["text_"..y].style.height = FONT_SIZE
				--gui.graph.table["col_"..x]["text_"..y].style.vertical_align = "top"
				--gui.graph.table["col_"..x]["text_"..y].style.single_line =false
				gui.graph.table["col_"..x]["text_"..y].style.want_ellipsis  =false
				gui.graph.table["col_"..x]["text_"..y].style.font = "rr-small-bold"
				gui.graph.table["col_"..x]["text_"..y].style.top_padding 		= 0
				gui.graph.table["col_"..x]["text_"..y].style.right_padding 	= 0
				gui.graph.table["col_"..x]["text_"..y].style.bottom_padding 	= 0
				gui.graph.table["col_"..x]["text_"..y].style.left_padding 	= 0	
				gui.graph.table["col_"..x]["text_"..y].style.scaleable = false
				
			end
		end
	end
end
function create_signals (gui,reactor_key)
	gui.add{type = "table", column_count = 6, name = "signals", direction = "horizontal"}
	gui.signals.style.top_padding 		= 0
	gui.signals.style.right_padding 	= 0
	gui.signals.style.bottom_padding 	= 0
	gui.signals.style.left_padding 	= 0
	gui.signals.style.horizontal_spacing= 0
	gui.signals.style.vertical_spacing=0
	gui.signals.style.scaleable = false
	
		gui.signals.add{type = "sprite-button", name = "temperature", sprite="virtual-signal/signal-reactor-core-temp", direction = "vertical"}
		gui.signals.temperature.number=0
		gui.signals.temperature.style.height = 	32
		gui.signals.temperature.style.width = 	32
		gui.signals.temperature.style.top_padding 	= 0
		gui.signals.temperature.style.right_padding 	= 0
		gui.signals.temperature.style.bottom_padding 	= 0
		gui.signals.temperature.style.left_padding 	= 0
		gui.signals.temperature.style.scaleable = false
		gui.signals.temperature.ignored_by_interaction =true
		
		gui.signals.add{type = "sprite-button", name = "power", sprite="virtual-signal/signal-reactor-power-output", direction = "vertical"}
		gui.signals.power.number=0
		gui.signals.power.style.height = 	32
		gui.signals.power.style.width = 	32
		gui.signals.power.style.top_padding 	= 0
		gui.signals.power.style.right_padding 	= 0
		gui.signals.power.style.bottom_padding 	= 0
		gui.signals.power.style.left_padding 	= 0
		gui.signals.power.style.scaleable = false
		gui.signals.power.ignored_by_interaction =true
		
		gui.signals.add{type = "sprite-button", name = "efficiency", sprite="virtual-signal/signal-reactor-efficiency", direction = "vertical"}
		gui.signals.efficiency.number=0
		gui.signals.efficiency.style.height = 	32
		gui.signals.efficiency.style.width = 	32
		gui.signals.efficiency.style.top_padding 	= 0
		gui.signals.efficiency.style.right_padding 	= 0
		gui.signals.efficiency.style.bottom_padding = 0
		gui.signals.efficiency.style.left_padding 	= 0
		gui.signals.efficiency.style.scaleable = false
		gui.signals.efficiency.ignored_by_interaction =true
		
		if global.reactors[reactor_key].displayer.name=="realistic-reactor-breeder" then
			gui.signals.add{type = "sprite-button", name = "bonuscells", sprite="rr-bonuscell-sprite", direction = "vertical"}
			gui.signals.bonuscells.number=0
			gui.signals.bonuscells.style.height = 	32
			gui.signals.bonuscells.style.width = 	32
			gui.signals.bonuscells.style.top_padding 	= 0
			gui.signals.bonuscells.style.right_padding 	= 0
			gui.signals.bonuscells.style.bottom_padding 	= 0
			gui.signals.bonuscells.style.left_padding 	= 0
			gui.signals.bonuscells.style.scaleable = false
			gui.signals.bonuscells.show_percent_for_small_numbers =true
			gui.signals.bonuscells.ignored_by_interaction =true
		end
		
		gui.signals.add{type = "sprite-button", name = "coolant", sprite="virtual-signal/signal-coolant-amount", direction = "vertical"}
		gui.signals.coolant.number=0
		gui.signals.coolant.style.height = 	32
		gui.signals.coolant.style.width = 	32
		gui.signals.coolant.style.top_padding 	= 0
		gui.signals.coolant.style.right_padding 	= 0
		gui.signals.coolant.style.bottom_padding 	= 0
		gui.signals.coolant.style.left_padding 	= 0
		gui.signals.coolant.style.scaleable = false
		gui.signals.coolant.ignored_by_interaction =true
		
		gui.signals.add{type = "sprite-button", name = "status", sprite="virtual-signal/signal-state-stopped", direction = "vertical"}
		gui.signals.status.number=0
		gui.signals.status.style.height = 	32
		gui.signals.status.style.width = 	32
		gui.signals.status.style.top_padding 	= 0
		gui.signals.status.style.right_padding 	= 0
		gui.signals.status.style.bottom_padding 	= 0
		gui.signals.status.style.left_padding 	= 0
		gui.signals.status.style.scaleable = false
		gui.signals.status.ignored_by_interaction =true

end

function create_progress (gui,reactor_key)
	gui.add{type = "table", column_count = 3, name = "progress", direction = "horizontal"}
	gui.progress.style.top_padding 		= 0
	gui.progress.style.right_padding 	= 0
	gui.progress.style.bottom_padding 	= 0
	gui.progress.style.left_padding 	= 0
	gui.progress.style.horizontal_spacing= 1
	gui.progress.style.vertical_spacing=1
	gui.progress.style.scaleable = false

	
		gui.progress.add{type = "sprite-button", name = "cells", sprite="rr-transparent-sprite", direction = "vertical"}
		gui.progress.cells.style.maximal_height = 	25
		gui.progress.cells.style.maximal_width = 	25
		gui.progress.cells.style.top_padding 	= 0
		gui.progress.cells.style.right_padding 	= 0
		gui.progress.cells.style.bottom_padding 	= 0
		gui.progress.cells.style.left_padding 	= 0
		gui.progress.cells.style.scaleable = false
		gui.progress.cells.ignored_by_interaction =true
	
		
		gui.progress.add{type = "table", column_count = 1, name = "bars", direction = "vertical"}
		gui.progress.bars.style.maximal_height = 28
		gui.progress.bars.style.maximal_width = 140
		gui.progress.bars.style.horizontal_spacing=0
		gui.progress.bars.style.vertical_spacing=0
		gui.progress.bars.style.top_padding 	= 4
		gui.progress.bars.style.right_padding 	= 0
		gui.progress.bars.style.bottom_padding 	= 0
		gui.progress.bars.style.left_padding 	= 0
		gui.progress.bars.style.scaleable = false
	
		
			gui.progress.bars.add{type = "progressbar", name = "progress", direction = "vertical"}
			gui.progress.bars.progress.style.height=12
			gui.progress.bars.progress.style.width=140
			gui.progress.bars.progress.style.top_padding 	= 0
			gui.progress.bars.progress.style.right_padding 	= 0
			gui.progress.bars.progress.style.bottom_padding	= 0
			gui.progress.bars.progress.style.left_padding 	= 0
			gui.progress.bars.progress.value=0
			gui.progress.bars.progress.style.color={r=1,g=0,b=0}
			gui.progress.bars.progress.style.scaleable = false
		
			if global.reactors[reactor_key].displayer.name=="realistic-reactor-breeder" then
				gui.progress.bars.add{type = "progressbar", name = "bonus_cells", direction = "vertical"}
				gui.progress.bars.bonus_cells.style.height=12
				gui.progress.bars.bonus_cells.style.width=140
				gui.progress.bars.bonus_cells.style.top_padding 	= 0
				gui.progress.bars.bonus_cells.style.right_padding 	= 0
				gui.progress.bars.bonus_cells.style.bottom_padding 	= 0
				gui.progress.bars.bonus_cells.style.left_padding 	= 0
				gui.progress.bars.bonus_cells.value=0
				gui.progress.bars.bonus_cells.style.color={r=0.8,g=0,b=0.8}
				gui.progress.bars.bonus_cells.style.scaleable = false
			else
				gui.progress.bars.style.top_padding 	= 7
			end
	
		
		gui.progress.add{type = "sprite-button", name = "used_cells", sprite="rr-transparent-sprite", direction = "vertical"}
		gui.progress.used_cells.style.height = 25
		gui.progress.used_cells.style.width 	= 25
		gui.progress.used_cells.style.top_padding 	= 0
		gui.progress.used_cells.style.right_padding 	= 0
		gui.progress.used_cells.style.bottom_padding = 0
		gui.progress.used_cells.style.left_padding 	= 0
		gui.progress.used_cells.style.scaleable = false
		gui.progress.used_cells.ignored_by_interaction =true
end